#
# Product configuration. This contents of this module will be imported into
# __init__.py and every content type module.
#
# If you wish to perform custom configuration, you may put a file AppConfig.py
# in your product's root directory. This will be included in this file if
# found.
#
from Products.CMFCore.CMFCorePermissions import setDefaultRoles

PROJECTNAME = "InventoryBuilder"

# Check for Plone 2.1
try:
    from Products.CMFPlone.migrations import v2_1
except ImportError:
    HAS_PLONE21 = False
else:
    HAS_PLONE21 = True
    
# Permissions
DEFAULT_ADD_CONTENT_PERMISSION = "Add portal content"
setDefaultRoles(DEFAULT_ADD_CONTENT_PERMISSION, ('Manager', 'Owner'))
ADD_CONTENT_PERMISSIONS = {
    'InventoryBuilder': 'Inventory Builder: Add inventory',
    'IBCategory': 'Inventory Builder: Add category',
    'IBItem': 'Inventory Builder: Add item',
    'IBImage': 'Add portal content',
    'IBFile': 'Add portal content',
}

setDefaultRoles('Inventory Builder: Add inventory', ('Manager', ))
setDefaultRoles('Inventory Builder: Add category', ('Manager', 'Member', 'Owner',))
setDefaultRoles('Inventory Builder: Add item', ('Manager', 'Member', 'Owner', 'Anonymous', ))
setDefaultRoles('Add portal content', ('Manager', 'Owner', ))
setDefaultRoles('Add portal content', ('Manager', 'Owner', ))

product_globals=globals()

# Dependencies of Products to be installed by quick-installer
# override in custom configuration
DEPENDENCIES = []

# Dependend products - not quick-installed - used in testcase
# override in custom configuration
PRODUCT_DEPENDENCIES = []

# You can overwrite these two in an AppConfig.py:
# STYLESHEETS = [{'id': 'my_global_stylesheet.css'},
#                {'id': 'my_contenttype.css',
#                 'expression': 'python:object.getTypeInfo().getId() == "MyType"}]
# You can do the same with JAVASCRIPTS.
STYLESHEETS = []
JAVASCRIPTS = []

##code-section config-bottom #fill in your manual code here
from Products.CMFCore.CMFCorePermissions import setDefaultRoles
setDefaultRoles('InventoryBuilder: Add Item', ('Authenticated',))
##/code-section config-bottom


# load custom configuration not managed by ArchGenXML
try:
    from Products.InventoryBuilder.AppConfig import *
except ImportError:
    pass

# End of config.py
