##parameters=get_my_items=False,ibuilder_path=None

# getIBItems - search results
# 1. if caled with get_my_items=True, returns items from all inventorybuilders and all categories of current user
# 2. if this script is called in the context of IBCategory, it returns only content in this category
# 3. REQUEST is searched for some pre-defined fields

request=context.REQUEST

#context.breakpoint()

query={'portal_type':'IBItem', 'sort_on':'created', 'sort_order':'reverse'}

limit_to_category = request.get('limit_to_category', None)
search_text = request.get('search_text', None)
# author  = request.get('author', None)
region  = request.get('region', None)
picture = request.get('picture', None)
want_expired = request.get('expired', None)
want_sold = request.get('sold', None)
age = request.get('age', None)
inventorybuilder = request.get('inventorybuilder_instance', None)

if inventorybuilder and inventorybuilder != 'all' and not ibuilder_path:
    # search only one inventorybuilder folder or category
    query['path'] = inventorybuilder
elif ibuilder_path != None:
    query['path'] = ibuilder_path
    
if search_text:
    query['SearchableText'] = search_text

if age and age!='all':
    age_attribute = 'created' 
    if   age=='day':
        query[age_attribute]={'query':context.ZopeTime()-1, 'range':'min'}    
    elif age=='threedays':
        query[age_attribute]={'query':context.ZopeTime()-3, 'range':'min'}    
    elif age=='week':
        query[age_attribute]={'query':context.ZopeTime()-7, 'range':'min'}    
    elif age=='threew':
        query[age_attribute]={'query':context.ZopeTime()-21, 'range':'min'}    
        
mtool = container.portal_membership
member = None
if not mtool.isAnonymousUser():
    member = mtool.getAuthenticatedMember()
    member_id=member.getProperty('id')
    member_manager = member.allowed('Manage portal') or member.allowed('Review portal content')
else:
    member_id='Anonymous user' # default value
    member_manager = 0

# override author with authenticated member id
author = None
if get_my_items and member:
    author = member_id

    
if (limit_to_category is not None) or (context.portal_type=='IBCategory'):
    query['listCategoryIds'] = context.getId()
    
if author:
    query['Creator']=author

items = container.portal_catalog(**query)

def filter_items(brain, item):
    """
    Filter item according to current filter options
    This method should be descriptive, not unreadable one-liner
    """

    result = item.Title()!=''
    result = result and (member_manager or brain.review_state=='public' or brain.Creator==member_id)
    if picture and picture!='all':
        result = result and hasattr(item,'getItemimage')
        if result:
            if picture=='picture_true':
                result = not not item.getItemimage()
            else:
                result = not item.getItemimage()
    return result
        
result=[]

for item in items:
    if item.portal_type == 'IBItem':
        obj = item.getObject()
        if obj:
            if not want_sold and item.review_state=='sold':
                # exclude expired items
                continue
            if get_my_items:    
                # ignore search filters
                result.append(obj)
            else:
                if filter_items(item, obj):
                    result.append(obj)
                
return result
