#
# PloneTestCase
#

from Testing import ZopeTestCase

# Make the boring stuff load quietly
ZopeTestCase.installProduct('CMFCore', quiet=1)
ZopeTestCase.installProduct('CMFDefault', quiet=1)
ZopeTestCase.installProduct('CMFCalendar', quiet=1)
ZopeTestCase.installProduct('CMFTopic', quiet=1)
ZopeTestCase.installProduct('DCWorkflow', quiet=1)
ZopeTestCase.installProduct('CMFActionIcons', quiet=1)
ZopeTestCase.installProduct('CMFQuickInstallerTool', quiet=1)
ZopeTestCase.installProduct('CMFFormController', quiet=1)
ZopeTestCase.installProduct('GroupUserFolder', quiet=1)
ZopeTestCase.installProduct('ZCTextIndex', quiet=1)
ZopeTestCase.installProduct('CMFPlone')

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)
ZopeTestCase.installProduct('ATSchemaEditorNG')
ZopeTestCase.installProduct('InventoryBuilder')

from Products.InventoryBuilder.config import *
from Products.PloneTestCase import PloneTestCase

PRODUCTS = ['Archetypes', 'ATSchemaEditorNG', 'InventoryBuilder']

PloneTestCase.setupPloneSite(products=PRODUCTS)

class InventoryBuilderTestCase( PloneTestCase.PloneTestCase ):
    '''TestCase for InventoryBuilder testing'''
    
    def afterSetUp(self):
        #self.portal.manage_permission(ADD_HELP_AREA_PERMISSION,
        #                              ['Manager', 'Owner'])
        self.setRoles(['Manager']) # or 'invokeFactory' will
                                   # raise Unauthorized in
                                   # _getFactoryMethod which calls
                                   # getSecurityManager().validate(...
        self._createInventoryBuilder(self.portal)  # add inventorybuilder to the plone site root
        # self.setRoles(['Member'])  # back to default role

    def _createInventoryBuilder(self, folder, id='inventorybuilder1', title='Test InventoryBuilder'):
        """
        Creates and returns a refence to a InventoryBuilder
        """
        folder.invokeFactory('InventoryBuilder',
                             id=id,
                             title=title,
                             description='A InventoryBuilder instance for unit tests.',
                             )
        inventorybuilder = getattr(folder, id)
        self.portal.portal_workflow.doActionFor(inventorybuilder, 'publish')
        return inventorybuilder

