#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.InventoryBuilder.tests import InventoryBuilderTestCase

class TestIBCategory(InventoryBuilderTestCase.InventoryBuilderTestCase):

    def afterSetUp(self):
        InventoryBuilderTestCase.InventoryBuilderTestCase.afterSetUp(self)  # creates inventorybuilder folder with id 'inventorybuilder1'
        self.inventorybuilder1 =  self.portal.inventorybuilder1
        self.inventorybuilder1.invokeFactory('IBCategory',
                                   id='category1',
                                   title='Test Category 1',
                                   description='A Category instance for unit tests.',
                                  )
        self.category1 = getattr(self.inventorybuilder1, 'category1')        

    def testCategoryId(self):
        self.assertEqual(self.category1.getId(), 'category1')

    def testListCategories(self):
        self.assertEqual(self.category1.listCategories(), [])
        self.assertEqual(self.category1.countItems(), 0)

    def testParentInventoryBuilder(self):
        self.assertEqual(self.category1.getParentInventoryBuilder(), self.inventorybuilder1)

    def testIBItems(self):
        self.inventorybuilder1.invokeFactory('IBItem',
                                   id='item1',
                                   title='Test Item 1',
                                   description='A Item instance for unit tests.',
                                  )
        self.item1 = getattr(self.inventorybuilder1, 'item1')
        self.item1.addToCategory(self.category1)
        self.assertEqual(self.category1.countItems(), 1)
        
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestIBCategory))
    return suite

if __name__ == '__main__':
    framework()

