#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.InventoryBuilder.tests import InventoryBuilderTestCase

class TestInventoryBuilder(InventoryBuilderTestCase.InventoryBuilderTestCase):

    def afterSetUp(self):
        InventoryBuilderTestCase.InventoryBuilderTestCase.afterSetUp(self)  # creates inventorybuilder folder with id 'inventorybuilder1'
        self.inventorybuilder1 =  self.portal.inventorybuilder1

    def testInventoryBuilderId(self):
        self.assertEqual(self.inventorybuilder1.getId(), 'inventorybuilder1')

    def testNewCategory(self):
        # create new category
        self.inventorybuilder1.invokeFactory('IBCategory',
                             id='category1',
                             title='Test Category 1',
                             description='A Category instance for unit tests.',
                             )
        category = getattr(self.inventorybuilder1, 'category1')
        folder_contents = self.inventorybuilder1.listCategories()
        self.assertEqual(len(folder_contents), 1)
        self.assertEqual(folder_contents[0], category)
        
    def testLastItems(self):
        self.assertEqual(self.inventorybuilder1.getInventoryBuilderLastItems('IBItem', 'published', count=999), [])
        
    def testContentsCompatibilityMethod(self):
        self.assertEqual(self.inventorybuilder1.getContents(), [])
        
    def testParentInventoryBuilder(self):
        self.assertEqual(self.inventorybuilder1.getParentInventoryBuilder(), self.inventorybuilder1)

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestInventoryBuilder))
    return suite

if __name__ == '__main__':
    framework()

