# File: InventoryBuilderTool.py
# 
# Copyright (c) 2005 by Copyright (c) 2005 SureCase.org Team.
# Generator: ArchGenXML Version 1.4.0-RC2 svn/development 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Radim Novotny <info@surecase.org>, Lukas Zdych <unknown>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



from Products.InventoryBuilder.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.InventoryBuilder.interfaces.IInventoryBuilderBaseObject import IInventoryBuilderBaseObject
##/code-section module-header

schema=Schema((
    StringField('id',
        widget=StringWidget(
            label='Id',
            label_msgid='InventoryBuilder_label_id',
            description_msgid='InventoryBuilder_help_id',
            i18n_domain='InventoryBuilder',
        ),
        mode="r"
    ),

    IntegerField('items_per_page_summary',
        default=20,
        widget=IntegerWidget(
            label="Items per page (items summary)",
            description="Enter number of items displayed per page in items summary listing by default (it can be temporarely changed by visitor during browsing the inventorybuilder).",
            label_msgid='InventoryBuilder_label_items_per_page_summary',
            description_msgid='InventoryBuilder_help_items_per_page_summary',
            i18n_domain='InventoryBuilder',
        ),
        required=True
    ),

    IntegerField('items_per_page_results',
        default=20,
        widget=IntegerWidget(
            label="Items per page (search results)",
            description="Enter number of items displayed per page in search results listing by default (it can be temporarely changed by visitor during browsing the inventorybuilder).",
            label_msgid='InventoryBuilder_label_items_per_page_results',
            description_msgid='InventoryBuilder_help_items_per_page_results',
            i18n_domain='InventoryBuilder',
        ),
        required=True
    ),

    LinesField('listing_table_columns',
        widget=InAndOutWidget
        (
            label="Listing Table Columns",
            description="Select one or more fields of IBItem, which will be displayed in the 'inventory items summary' and 'search results' listing tables.",
            label_msgid='InventoryBuilder_label_listing_table_columns',
            description_msgid='InventoryBuilder_help_listing_table_columns',
            i18n_domain='InventoryBuilder',
        ),
        required=False,
        mode="rw",
        vocabulary="getAvailableItemFields",
        default=VOC_LISTING_COLUMNS,
        enforceVocabulary=1
    ),

    IntegerField('summary_columns',
        default=2,
        widget=IntegerWidget(
            label="Summary Columns",
            description="Set number of columns used in summary view templates by default. This can be individually set by giving property 'summary_columns' (int) with individual value to Folder instance in ZMI.",
            label_msgid='InventoryBuilder_label_summary_columns',
            description_msgid='InventoryBuilder_help_summary_columns',
            i18n_domain='InventoryBuilder',
        ),
        schemata="Summary"
    ),

    IntegerField('summary_last_items_count',
        default=5,
        widget=IntegerWidget(
            label="Last Items Count",
            description="Set number of last items used in summary view templates by default as count of displayd items inside each portlet box. This can be individually set by giving property 'summary_last_items_count' (int) with individual value to Folder instance in ZMI.",
            label_msgid='InventoryBuilder_label_summary_last_items_count',
            description_msgid='InventoryBuilder_help_summary_last_items_count',
            i18n_domain='InventoryBuilder',
        ),
        schemata="Summary"
    ),

    BooleanField('summary_display_counts',
        widget=BooleanWidget(
            label="Display Counts",
            description="Check this option to display count of contained inventory items in each inventory listed in summary view templates by default. This can be individually set by giving property 'summary_display_counts' (boolean) with individual value to Folder instance in ZMI. Usage of this feature is not recommended for large inventories because of performance cost.",
            label_msgid='InventoryBuilder_label_summary_display_counts',
            description_msgid='InventoryBuilder_help_summary_display_counts',
            i18n_domain='InventoryBuilder',
        ),
        schemata="Summary"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

InventoryBuilderTool_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
InventoryBuilderTool_schema = InventoryBuilderTool_schema.copy()
InventoryBuilderTool_schema['title'].widget.visible = {'view':'invisible', 'edit':'invisible'}
InventoryBuilderTool_schema['title'].required = False
##/code-section after-schema

class InventoryBuilderTool(UniqueObject,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'InventoryBuilderTool'

    meta_type                  = 'InventoryBuilderTool'
    portal_type                = 'InventoryBuilderTool'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'InventoryBuilderTool.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "InventoryBuilderTool"
    typeDescMsgId              = 'description_edit_inventorybuildertool'
    #toolicon                   = 'InventoryBuilderTool.gif'

    schema = InventoryBuilderTool_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_inventorybuildertool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods

    security.declareProtected(EDIT_PERMISSION, 'getAvailableItemFields')
    def getAvailableItemFields(self):
        """
        Return all available IBItem fields which can be displayed
        in 'my inventorybuilder items' and search results listing tables.
        """

        # find all existing InventoryBuilders
        pc = getToolByName(self, 'portal_catalog')
        inventorybuilder_folders = pc.searchResults(portal_type='InventoryBuilder')
        
        # go through all InventoryBuilders and make a list of fields
        # which are registered for IBItem in all of them
        fields_list = {}
        inventorybuilder_instances = []
        for inventorybuilder in inventorybuilder_folders:
            inventorybuilder = inventorybuilder.getObject()
            if inventorybuilder != None:
                fields_list[inventorybuilder.getId()] = inventorybuilder.atse_getSchemaById('IBItem').fields()
                inventorybuilder_instances.append(inventorybuilder)

        unwanted_modes = ('invisible', 'hidden')
        unwanted_schemata = ('metadata',)
        results = DisplayList()

        for fields in fields_list.values():
            for field in fields:
                f_view = field.widget.visible['view']
                if f_view not in unwanted_modes and field.schemata not in unwanted_schemata:
                    key = field.getName()

                    isAvailable = True
                    # check if field is in all InventoryBuilders
                    for f_list in fields_list.values():
                        hasField = False
                        for f in f_list:
                            if key == f.getName():
                                hasField = True
                        if not hasField:
                            isAvailable = False
                            break
                        
                    if isAvailable and key not in results.keys():
                        results.add(key, field.widget.label,'inventorybuilder_voc_' + key)

        return results
        


    security.declareProtected(VIEW_PERMISSION, 'getIBItemSchema')
    def getIBItemSchema(self):
        """
        Return IBItem schemata.
        """
        
        # any of existing InventoryBuilders
        pc = getToolByName(self, 'portal_catalog')
        inventorybuilder_brains = pc.searchResults(portal_type='InventoryBuilder')

        inventorybuilder = None
        for brain in inventorybuilder_brains:
            inventorybuilder = brain.getObject()
            if inventorybuilder != None:
                break
        
        if inventorybuilder != None:
            return inventorybuilder.atse_getSchemaById('IBItem')

        return None



    security.declarePublic('getInventoryBuilderLastItems')
    def getInventoryBuilderLastItems(self, context):
        """
        Helper method for portlet_last_inventorybuilder_items
        """
        isInventoryBuilderContent = IInventoryBuilderBaseObject.isImplementedBy(context)
        pc = getToolByName(self, 'portal_catalog')
        q = {'portal_type':'IBItem', 'sort_on':'Date', 'sort_order':'reverse'}
        if isInventoryBuilderContent:
            q['path'] = '/'.join(context.getParentInventoryBuilder().getPhysicalPath())

        return pc.searchResults(q)[:5]



registerType(InventoryBuilderTool,PROJECTNAME)
# end of class InventoryBuilderTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



