# File: IBCategory.py
# 
# Copyright (c) 2005 by Copyright (c) 2005 SureCase.org Team.
# Generator: ArchGenXML Version 1.4.0-RC2 svn/development 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Radim Novotny <info@surecase.org>, Lukas Zdych <unknown>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATContentTypes.content.folder import ATFolder
from Products.InventoryBuilder.interfaces.IInventoryBuilderBaseObject import IInventoryBuilderBaseObject
from Products.InventoryBuilder.interfaces.IInventoryBuilderObject import IInventoryBuilderObject


from Products.InventoryBuilder.config import *
##code-section module-header #fill in your manual code here
if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import *

from Products.InventoryBuilder.util import SQLStorage, filterContents
from DateTime import DateTime
from Products.CMFCore.CMFCorePermissions import AccessInactivePortalContent
from Products.CMFCore.utils import _checkPermission
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema=Schema((
    ImageField('folderimage',
        widget=ImageWidget(
            label="Image",
            description="You may upload image. Image will be automatically scaled",
            label_msgid='InventoryBuilder_label_folderimage',
            description_msgid='InventoryBuilder_help_folderimage',
            i18n_domain='InventoryBuilder',
        ),
        languageIndependent=True,
        storage=AnnotationStorage(migrate=True),
        original_size=(500,500),
        sizes={'small':(64,64), 'mini':(32,32)}
    ),

    LinesField('allowed_types',
        widget=MultiSelectionWidget(
            label="Allowed types",
            description="Select which inventorybuilder content types can be added to this category.",
            visible={'edit':'hidden', 'view':'hidden'},
            label_msgid='InventoryBuilder_label_allowed_types',
            description_msgid='InventoryBuilder_help_allowed_types',
            i18n_domain='InventoryBuilder',
        ),
        languageIndependent=True,
        multiValued=1,
        vocabulary=VOC_ALLOWED_TYPES,
        default="InventoryBuilder Item",
        storage=AnnotationStorage(migrate=True)
    ),

    IntegerField('categories_listing_columns',
        default=2,
        schemata="UI",
        widget=IntegerWidget(
            label="Subcategories columns",
            description="Enter number of columns to show category subcategories in.",
            label_msgid='InventoryBuilder_label_categories_listing_columns',
            description_msgid='InventoryBuilder_help_categories_listing_columns',
            i18n_domain='InventoryBuilder',
        ),
        languageIndependent=True,
        storage=AnnotationStorage(migrate=True)
    ),

    BooleanField('use_subcategories',
        widget=BooleanWidget(
            label="Use Subcategories",
            description="If this option is checked, the button for creating subcategories will be displayed on inventory category page.",
            label_msgid='InventoryBuilder_label_use_subcategories',
            description_msgid='InventoryBuilder_help_use_subcategories',
            i18n_domain='InventoryBuilder',
        ),
        languageIndependent=True,
        schemata="UI",
        accessor="allowSubcategories",
        default_method="setAllowSubcategories"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

IBCategory_schema = getattr(ATFolder,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class IBCategory(ATFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATFolder,'__implements__',()),) + (IInventoryBuilderBaseObject,IInventoryBuilderObject,)


    # This name appears in the 'add' box
    archetype_name             = 'InventoryBuilder Category'

    meta_type                  = 'IBCategory'
    portal_type                = 'IBCategory'
    allowed_content_types      = ['IBCategory'] + list(getattr(ATFolder, 'allowed_content_types', []))
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'inventorybuilder_category_icon.gif'
    immediate_view             = 'inventorybuildercategory_view'
    default_view               = 'inventorybuildercategory_view'
    suppl_views                = ()
    typeDescription            = "InventoryBuilder Category"
    typeDescMsgId              = 'description_edit_ibcategory'

    actions =  (


       {'action':      "string:${object_url}/inventorybuildercategory_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (VIEW_PERMISSION,),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/inventorybuildercategory_edit",
        'category':    "object",
        'id':          'edit',
        'name':        'Edit',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/sharing",
        'category':    "object",
        'id':          'sharing',
        'name':        'Sharing',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/inventorybuilder_items",
        'category':    "object",
        'id':          'items',
        'name':        'Items',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },


    )

    schema = IBCategory_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected(VIEW_PERMISSION, 'setAllowSubcategories')
    def setAllowSubcategories(self):
        """
        Return value of attribute use_subcategories from parent category object
        or use_categories from parent inventory object.
        """
        
        prnt = self.aq_parent
        if prnt.portal_type == 'IBCategory':
            return prnt.allowSubcategories()
        elif prnt.portal_type == 'InventoryBuilder':
            return prnt.allowCategories()
        else:
            return False


    #methods from Interface IInventoryBuilderBaseObject

    security.declareProtected(VIEW_PERMISSION, 'getParentInventoryBuilder')
    def getParentInventoryBuilder(self):
        """
        Return first inventorybuilder folder in folder hierarchy (parent inventorybuilder)
        """
        obj = self.aq_parent
        while obj.portal_type!='InventoryBuilder':
            obj=obj.aq_parent
        return obj



    security.declareProtected(VIEW_PERMISSION, 'getDisplayValue')
    def getDisplayValue(self, obj, fieldname, key):
        """
        Returns vocabulary title from given object, fieldname and key.
        """
        
        field = obj.getField(fieldname)
        if not key:
            key = field.get(obj)
            
            if key and key!='undefined':
                vocab = field.Vocabulary(obj)
                msgid = vocab.getMsgId(key)
                return translate(msgid=msgid, default=vocab.getValue(key), domain='InventoryBuilder')
            else:
                return ''



    security.declareProtected(VIEW_PERMISSION, 'listAttachments')
    def listAttachments(self):
        """
        
        """
        
        pass



    security.declareProtected(VIEW_PERMISSION, 'getBuildInImages')
    def getBuildInImages(self):
        """
        
        """
        
        pass



    security.declareProtected(VIEW_PERMISSION, 'formatMultiSelectionValue')
    def formatMultiSelectionValue(self):
        """
        
        """
        
        pass



    security.declareProtected(VIEW_PERMISSION, 'validateFieldAccess')
    def validateFieldAccess(self, userid):
        """
        Check if user has one at least one of trusted roles.
        """

        ibuilder = self.getParentInventoryBuilder()
        trusted_roles = ibuilder.getTrusted_roles()
        result = False
        for role in trusted_roles:
            if userid.has_role(role, self):
                result = True
                break

        return result


    #methods from Interface IInventoryBuilderObject

    security.declareProtected(VIEW_PERMISSION, 'listCategories')
    def listCategories(self):
        """
        Returns list of IBCategory objects inside itself.
        """
        
        return self.listFolderContents(contentFilter={'portal_type':'IBCategory'})



    security.declareProtected(VIEW_PERMISSION, 'getContents')
    def getContents(self,filter={}):
        """
        Return a list of objects that are registered inside the
        category.
        The result could be filtered using a dictionary, where the keys
        are object
        properties and the values are acceptable values for these keys.
        """
        
        return filterContents(self.getBRefs("category"), filter)     



    security.declareProtected(VIEW_PERMISSION, 'countItems')
    def countItems(self):
        """
        Return grand count of items in folder (category) and it's contents.
        """

        pm = getToolByName(self, 'portal_membership')
        mbr = pm.getAuthenticatedMember()
        subcats = self.listCategories()

        count = 0
        for i in subcats:
            count = count + i.countItems()

        for content in self.getContents():
            if mbr.has_permission('View', content):
                count += 1

        return count
    


registerType(IBCategory,PROJECTNAME)
# end of class IBCategory

##code-section module-footer #fill in your manual code here
##/code-section module-footer



