# File: IBItem.py
# 
# Copyright (c) 2005 by Copyright (c) 2005 SureCase.org Team.
# Generator: ArchGenXML Version 1.4.0-RC2 svn/development 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Radim Novotny <info@surecase.org>, Lukas Zdych <unknown>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATSchemaEditorNG.ParentManagedSchema import ParentManagedSchema
from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.document import ATDocument
from Products.InventoryBuilder.interfaces.IInventoryBuilderBaseObject import IInventoryBuilderBaseObject


# additional imports from tagged value 'import'
from Products.ATSchemaEditorNG.config import ATSE_MANAGED_FULL, ATSE_MANAGED_NONE

from Products.InventoryBuilder.config import *
##code-section module-header #fill in your manual code here
if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import *

from Products.CMFCore.utils import getToolByName
from DateTime import DateTime
from Products.InventoryBuilder.lib.HTMLStripper import HTMLStrip
##/code-section module-header

schema=Schema((
),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

IBItem_schema = getattr(ParentManagedSchema,'schema',Schema(())) + \
    getattr(ATFolder,'schema',Schema(())) + \
    getattr(ATDocument,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
# hide ATCT schemata fields from ATSE
IBItem_schema = getattr(ParentManagedSchema,'schema',Schema(())).copy() + \
                    getattr(ATFolder,'schema',Schema(())).copy() + \
                    getattr(ATDocument,'schema',Schema(())).copy() + \
                    schema
IBItem_schema['id'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['title'].widget.visible = {'edit':'visible', 'view':'visible'}
IBItem_schema['description'].atse_managed=ATSE_MANAGED_FULL
IBItem_schema['description'].isMetadata = False
IBItem_schema['description'].schemata='default'
IBItem_schema['constrainTypesMode'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['locallyAllowedTypes'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['immediatelyAddableTypes'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['relatedItems'].atse_managed=ATSE_MANAGED_FULL
IBItem_schema['relatedItems'].schemata='metadata'
IBItem_schema['allowDiscussion'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['allowDiscussion'].schemata='metadata'
IBItem_schema['text'].atse_managed=ATSE_MANAGED_NONE
IBItem_schema['text'].required=False
IBItem_schema['text'].widget.visible={'edit':'hidden', 'view':'hidden'}
##/code-section after-schema

class IBItem(ParentManagedSchema,ATFolder,ATDocument):
    security = ClassSecurityInfo()
    __implements__ = (getattr(ParentManagedSchema,'__implements__',()),) + (getattr(ATFolder,'__implements__',()),) + (getattr(ATDocument,'__implements__',()),) + (IInventoryBuilderBaseObject,)


    # This name appears in the 'add' box
    archetype_name             = 'InventoryBuilder Item'

    meta_type                  = 'IBItem'
    portal_type                = 'IBItem'
    allowed_content_types      = ['IBImage', 'IBFile'] + list(getattr(ParentManagedSchema, 'allowed_content_types', [])) + list(getattr(ATFolder, 'allowed_content_types', [])) + list(getattr(ATDocument, 'allowed_content_types', []))
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 1
    content_icon               = 'inventorybuilder_item_icon.gif'
    immediate_view             = 'inventorybuilderitem_view'
    default_view               = 'inventorybuilderitem_view'
    suppl_views                = ()
    typeDescription            = "InventoryBuilder Item"
    typeDescMsgId              = 'description_edit_ibitem'

    actions =  (


       {'action':      "string:${object_url}/inventorybuilderitem_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (VIEW_PERMISSION,),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/inventorybuilderitem_edit",
        'category':    "object",
        'id':          'edit',
        'name':        'Edit',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/inventorybuilder_categories",
        'category':    "object",
        'id':          'categories',
        'name':        'Categories',
        'permissions': (EDIT_PERMISSION,),
        'condition'  : 'python:1'
       },


    )

    schema = IBItem_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        ATFolder.manage_afterAdd(self, item, container)
        self.accessor_called = False
        self.mutator_called = False



    security.declareProtected(EDIT_PERMISSION, 'addToCategory')
    def addToCategory(self,category):
        """
        Add the object to a category.
        """
        
        self.addReference(category, "category")



    security.declareProtected(EDIT_PERMISSION, 'removeFromCategory')
    def removeFromCategory(self,category):
        """
        Remove the object from a category.        
        """
        
        self.deleteReference(category, "category")



    security.declareProtected(VIEW_PERMISSION, 'listCategories')
    def listCategories(self):
        """
        List the categories where the object is registered.        
        This method is used for cataloging a list of categories 
        in the portal catalog
        """
        return self.getRefs("category")



    security.declareProtected(VIEW_PERMISSION, 'fieldExists')
    def fieldExists(self,field_id):
        """
        Check if requested field exists in item schematas.
        """

        schema = self.atse_getSchemaById('IBItem')
        schemata = self.atse_getSchemataNames('IBItem')
        result = False

        for s in schemata:
            for field in schema.getSchemataFields(s):
                if field_id == field.getName():
                    return True

        return result



    security.declareProtected(VIEW_PERMISSION, 'listCategoryIds')
    def listCategoryIds(self):
        """
        Returns a list of category Ids in which item is assigned. Used
        for portal_catalog.
        """

        result = []
        for category in self.listCategories():
            if category:
                result.append(category.getId())
        return result       



    security.declareProtected(EDIT_PERMISSION, 'setMaskedFieldValue')
    def setMaskedFieldValue(self, fieldname, value, **kwargs):
        """
        Set the field value (remove unallowed HTML tags)
        """
        bf = self.getParentInventoryBuilder()
        valid_tags = bf.getAllowed_html_tags()
        body = HTMLStrip(value, valid_tags)
        self.getField(fieldname).set(self, body, **kwargs)



    security.declareProtected(VIEW_PERMISSION, 'getMaskedFieldValue')
    def getMaskedFieldValue(self, fieldname, mask=True):
        """
        Accessor for field, returns masked value
        """
        fieldv = self.getField(fieldname).get(self)

        if mask:
            # replace banned words.
            bf = self.getParentInventoryBuilder()
            bwords = bf.bannedWords()
            cover = bf.coverString()

            import re
            for w in bwords:
                word = w['word'] or None
                replacement = w['replacement'] or cover
                if word != None:
                    rE = re.compile(r"\b%s\b" % word, re.I)
                    fieldv = rE.sub(replacement, fieldv)

        return fieldv



    security.declareProtected(VIEW_PERMISSION, 'Description')
    def Description(self):
        """
        Description field accessor
        """
        return self.getMaskedFieldValue('description')



    security.declareProtected(EDIT_PERMISSION, 'setDescription')
    def setDescription(self,value, **kwargs):
        """
        Description field mutator
        """
        self.setMaskedFieldValue('description', value, **kwargs)



    security.declareProtected(VIEW_PERMISSION, 'getLayout')
    def getLayout(self):
        """
        Return default layout for IBItem instance taken from parent
        InventoryBuilder instance.
        """
        
        ibuilder = self.getParentInventoryBuilder()
        return ibuilder.getItems_layout() or 'inventorybuilderitem_view'


    #methods from Interface IInventoryBuilderBaseObject

    security.declareProtected(VIEW_PERMISSION, 'getParentInventoryBuilder')
    def getParentInventoryBuilder(self):
        """
        Return first inventorybuilder folder in folder hierarchy (parent inventorybuilder)
        """
        obj = self.aq_parent
        while obj.portal_type!='InventoryBuilder':
            obj=obj.aq_parent
        return obj



    security.declareProtected(VIEW_PERMISSION, 'getDisplayValue')
    def getDisplayValue(self, obj, fieldname, key):
        """
        Returns vocabulary title from given object, fieldname and key.
        """
        
        field = obj.getField(fieldname)
        if not key:
            key = field.get(obj)
            
            if key and key!='undefined':
                vocab = field.Vocabulary(obj)
                msgid = vocab.getMsgId(key)
                return translate(msgid=msgid, default=vocab.getValue(key), domain='InventoryBuilder')
            else:
                return ''



    security.declareProtected(VIEW_PERMISSION, 'listAttachments')
    def listAttachments(self, portal_types=None):
        """
        Return existing attachments by given portal type(s).
        """
        
        return self.getFolderContents(contentFilter={'portal_type':portal_types,})



    security.declareProtected(VIEW_PERMISSION, 'getBuildInImages')
    def getBuildInImages(self, scale=None):
        """
        Returns all images in ibitem schema
        """
        schema = self.atse_getSchemaById('IBItem')
        imageFields = []
        for f in schema.fields():
            if f.type=='image':
                imageFields.append(f)
                
        result = []
        for field in imageFields:
            # image has to have required scale to be able to display thumbnail!
            # by default 'small' and 'thumb' scales are used ('small' is required)
            if (scale is not None) and (scale in field.getAvailableSizes(field).keys()):
                # is image uploaded ? 
                if not not field.get(self):
                    size = field.getSize(self)
                    result.append({'fieldname':field.getName(), 'scale':field.tag(self, scale=scale), 'width':size[0], 'height':size[1] })

        return result



    security.declareProtected(VIEW_PERMISSION, 'formatMultiSelectionValue')
    def formatMultiSelectionValue(self, obj, fieldname, values):
        """
        Return multiselection widget value where keys are replaced by values.
        """

        field = obj.getField(fieldname)
        if not values:
            values = field.get(obj)

        valuesDict = []
        if values and values != 'undefined':
            vocab = field.Vocabulary(obj)
            for value in values:
                if value:
                    valuesDict.append(vocab.getValue(value))

        return ', '.join(valuesDict)



    security.declareProtected(VIEW_PERMISSION, 'validateFieldAccess')
    def validateFieldAccess(self, userid):
        """
        Check if user has one at least one of trusted roles.
        """

        ibuilder = self.getParentInventoryBuilder()
        trusted_roles = ibuilder.getTrusted_roles()
        result = False
        for role in trusted_roles:
            if userid.has_role(role, self):
                result = True
                break

        return result
        


registerType(IBItem,PROJECTNAME)
# end of class IBItem

##code-section module-footer #fill in your manual code here
##/code-section module-footer



