from config import *
from Products.Archetypes.Storage import AttributeStorage
from Products.Archetypes.SQLStorage import PostgreSQLStorage, MySQLSQLStorage

SQLStorage = AttributeStorage()

if use_postgresql:
    try:
        from Products import ZPsycopgDA
    except ImportError:
        pass
    else:
        SQLStorage = PostgreSQLStorage()
        print "PloneMall using Postgresql..."

if use_mysql:
    try:
        from Products import ZMySQLDA
    except ImportError:
        pass
    else:
        SQLStorage = MySQLSQLStorage()
        print "PloneMall using MySQL..."

def filterContents(objects, filter = {}):
    ret = []
    for obj in objects:
        flag_ok = 1
        for k, v in filter.items():
            if hasattr(obj, k):
                attr = getattr(obj, k)
                if callable(attr):
                    attr = attr()
                if attr != v:
                    flag_ok = 0
                    break
        if flag_ok:
            ret.append(obj)
    return ret
